Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.ec2
Class AmazonEC2Client

    java.lang.Object
      com.amazonaws.AmazonWebServiceClient
          com.amazonaws.services.ec2.AmazonEC2Client

All Implemented Interfaces:
  AmazonEC2

Direct Known Subclasses:
  AmazonEC2AsyncClient

    public class AmazonEC2Client

extends AmazonWebServiceClient
implements AmazonEC2

Client for accessing AmazonEC2. All service calls made using this client are blocking, and will not return until the service call completes.

Amazon Elastic Compute Cloud (Amazon EC2) is a web service that provides resizable compute capacity in the cloud. It is designed to make web-scale computing easier for developers.

Amazon EC2's simple web service interface allows you to obtain and configure capacity with minimal friction. It provides you with complete control of your computing resources and lets you run on Amazon's proven computing environment. Amazon EC2 reduces the time required to obtain and boot new server instances to minutes, allowing you to quickly scale capacity, both up and down, as your computing requirements change. Amazon EC2 changes the economics of computing by allowing you to pay only for capacity that you actually use. Amazon EC2 provides developers the tools to build failure resilient applications and isolate themselves from common failure scenarios.

Visit http://aws.amazon.com/ec2/ for more information.

Constructor Summary
`AmazonEC2Client(AWSCredentials awsCredentials)` Constructs a new client to invoke service methods on AmazonEC2 using the specified AWS account credentials.
`AmazonEC2Client(AWSCredentials awsCredentials, ClientConfiguration clientConfiguration)` Constructs a new client to invoke service methods on AmazonEC2 using the specified AWS account credentials and client configuration options.

Method Summary
`void` | `activateLicense(ActivateLicenseRequest activateLicenseRequest)` Activates a specific number of licenses for a 90-day period.
`AllocateAddressResult` | `allocateAddress()` The AllocateAddress operation acquires an elastic IP address for use with your account.
`AllocateAddressResult` | `allocateAddress(AllocateAddressRequest allocateAddressRequest)` The AllocateAddress operation acquires an elastic IP address for use with your account.
`void` | `associateAddress(AssociateAddressRequest associateAddressRequest)` The AssociateAddress operation associates an elastic IP address with an instance.
`void` | `associateDhcpOptions(AssociateDhcpOptionsRequest associateDhcpOptionsRequest)` Associates a set of DHCP options (that you've previously created) with the specified VPC.
`AttachVolumeResult` | `attachVolume(AttachVolumeRequest attachVolumeRequest)` Attach a previously created volume to a running instance.
`AttachVpnGatewayResult` | `attachVpnGateway(AttachVpnGatewayRequest attachVpnGatewayRequest)` Attaches a VPN gateway to a VPC.
`void` | `authorizeSecurityGroupIngress(AuthorizeSecurityGroupIngressRequest authorizeSecurityGroupIngressRequest)` The AuthorizeSecurityGroupIngress operation adds permissions to a security group.
`BundleInstanceResult` | `bundleInstance(BundleInstanceRequest bundleInstanceRequest)` The BundleInstance operation request that an instance is bundled the next time it boots.
`CancelBundleTaskResult` | `cancelBundleTask(CancelBundleTaskRequest cancelBundleTaskRequest)` CancelBundleTask operation cancels a pending or in-progress bundling task.
`CancelSpotInstanceRequestsResult` | `cancelSpotInstanceRequests(CancelSpotInstanceRequestsRequest cancelSpotInstanceRequestsRequest)` Cancels one or more Spot Instance requests.
`ConfirmProductInstanceResult` | `confirmProductInstance(ConfirmProductInstanceRequest confirmProductInstanceRequest)` The ConfirmProductInstance operation returns true if the specified product code is attached to the specified instance.
`CreateCustomerGatewayResult` | `createCustomerGateway(CreateCustomerGatewayRequest createCustomerGatewayRequest)` Provides information to AWS about your customer gateway device.
`CreateDhcpOptionsResult` | `createDhcpOptions(CreateDhcpOptionsRequest createDhcpOptionsRequest)` Creates a set of DHCP options that you can then associate with one or more VPCs, causing all existing and new instances that you launch in those VPCs to use the set of DHCP options.
`CreateImageResult` | `createImage(CreateImageRequest createImageRequest)` Creates an AMI that uses an Amazon EBS root device from a "running" or "stopped" instance.
`CreateKeyPairResult` | `createKeyPair(CreateKeyPairRequest createKeyPairRequest)` The CreateKeyPair operation creates a new 2048 bit RSA key pair and returns a unique ID that can be used to reference this key pair when launching new instances.
`void` | `createPlacementGroup(CreatePlacementGroupRequest createPlacementGroupRequest)` Creates a PlacementGroup into which multiple Amazon EC2 instances can be launched.
`void` | `createSecurityGroup(CreateSecurityGroupRequest createSecurityGroupRequest)` The CreateSecurityGroup operation creates a new security group.
`CreateSnapshotResult` | `createSnapshot(CreateSnapshotRequest createSnapshotRequest)` Create a snapshot of the volume identified by volume ID.
`CreateSpotDatafeedSubscriptionResult` | `createSpotDatafeedSubscription(CreateSpotDatafeedSubscriptionRequest createSpotDatafeedSubscriptionRequest)` Creates the data feed for Spot Instances, enabling you to view Spot Instance usage logs.
`CreateSubnetResult` | `createSubnet(CreateSubnetRequest createSubnetRequest)` Creates a subnet in an existing VPC.
`CreateVolumeResult` | `createVolume(CreateVolumeRequest createVolumeRequest)` Initializes an empty volume of a given size.
`CreateVpcResult` | `createVpc(CreateVpcRequest createVpcRequest)` Creates a VPC with the CIDR block you specify.
`CreateVpnConnectionResult` | `createVpnConnection(CreateVpnConnectionRequest createVpnConnectionRequest)` Creates a new VPN connection between an existing VPN gateway and customer gateway.
`CreateVpnGatewayResult` | `createVpnGateway(CreateVpnGatewayRequest createVpnGatewayRequest)` Creates a new VPN gateway.
`void` | `deactivateLicense(DeactivateLicenseRequest deactivateLicenseRequest)` Deactivates a specific number of licenses.
`void` | `deleteCustomerGateway(DeleteCustomerGatewayRequest deleteCustomerGatewayRequest)` Deletes a customer gateway.
`void` | `deleteDhcpOptions(DeleteDhcpOptionsRequest deleteDhcpOptionsRequest)` Deletes a set of DHCP options that you specify.
`void` | `deleteKeyPair(DeleteKeyPairRequest deleteKeyPairRequest)` The DeleteKeyPair operation deletes a key pair.
`void` | `deletePlacementGroup(DeletePlacementGroupRequest deletePlacementGroupRequest)` Deletes a PlacementGroup from a user's account.
`void` | `deleteSecurityGroup(DeleteSecurityGroupRequest deleteSecurityGroupRequest)` The DeleteSecurityGroup operation deletes a security group.
`void` | `deleteSnapshot(DeleteSnapshotRequest deleteSnapshotRequest)` Deletes the snapshot identified by snapshotId.
`void` | `deleteSpotDatafeedSubscription()` Deletes the data feed for Spot Instances.
`void` | `deleteSpotDatafeedSubscription(DeleteSpotDatafeedSubscriptionRequest deleteSpotDatafeedSubscriptionRequest)` Deletes the data feed for Spot Instances.
`void` | `deleteSubnet(DeleteSubnetRequest deleteSubnetRequest)` Deletes a subnet from a VPC.
`void` | `deleteVolume(DeleteVolumeRequest deleteVolumeRequest)` Deletes a previously created volume.
`void` | `deleteVpc(DeleteVpcRequest deleteVpcRequest)` Deletes a VPC.
`void` | `deleteVpnConnection(DeleteVpnConnectionRequest deleteVpnConnectionRequest)` Deletes a VPN connection.
`void` | `deleteVpnGateway(DeleteVpnGatewayRequest deleteVpnGatewayRequest)` Deletes a VPN gateway.
`void` | `deregisterImage(DeregisterImageRequest deregisterImageRequest)` The DeregisterImage operation deregisters an AMI.
`DescribeAddressesResult` | `describeAddresses()` The DescribeAddresses operation lists elastic IP addresses assigned to your account.
`DescribeAddressesResult` | `describeAddresses(DescribeAddressesRequest describeAddressesRequest)` The DescribeAddresses operation lists elastic IP addresses assigned to your account.
`DescribeAvailabilityZonesResult` | `describeAvailabilityZones()` The DescribeAvailabilityZones operation describes availability zones that are currently available to the account and their states.
`DescribeAvailabilityZonesResult` | `describeAvailabilityZones(DescribeAvailabilityZonesRequest describeAvailabilityZonesRequest)` The DescribeAvailabilityZones operation describes availability zones that are currently available to the account and their states.
`DescribeBundleTasksResult` | `describeBundleTasks()` The DescribeBundleTasks operation describes in-progress and recent bundle tasks.
`DescribeBundleTasksResult` | `describeBundleTasks(DescribeBundleTasksRequest describeBundleTasksRequest)` The DescribeBundleTasks operation describes in-progress and recent bundle tasks.
`DescribeCustomerGatewaysResult` | `describeCustomerGateways()` Gives you information about your customer gateways.
`DescribeCustomerGatewaysResult` | `describeCustomerGateways(DescribeCustomerGatewaysRequest describeCustomerGatewaysRequest)` Gives you information about your customer gateways.
`DescribeDhcpOptionsResult` | `describeDhcpOptions()` Gives you information about one or more sets of DHCP options.
`DescribeDhcpOptionsResult` | `describeDhcpOptions(DescribeDhcpOptionsRequest describeDhcpOptionsRequest)` Gives you information about one or more sets of DHCP options.
`DescribeImageAttributeResult` | `describeImageAttribute(DescribeImageAttributeRequest describeImageAttributeRequest)` The DescribeImageAttribute operation returns information about an attribute of an AMI.
`DescribeImagesResult` | `describeImages()` The DescribeImages operation returns information about AMIs, AKIs, and ARIs available to the user.
`DescribeImagesResult` | `describeImages(DescribeImagesRequest describeImagesRequest)` The DescribeImages operation returns information about AMIs, AKIs, and ARIs available to the user.
`DescribeInstanceAttributeResult` | `describeInstanceAttribute(DescribeInstanceAttributeRequest describeInstanceAttributeRequest)` Returns information about an attribute of an instance.
`DescribeInstancesResult` | `describeInstances()` The DescribeInstances operation returns information about instances that you own.
`DescribeInstancesResult` | `describeInstances(DescribeInstancesRequest describeInstancesRequest)` The DescribeInstances operation returns information about instances that you own.
`DescribeKeyPairsResult` | `describeKeyPairs()` The DescribeKeyPairs operation returns information about key pairs available to you.
`DescribeKeyPairsResult` | `describeKeyPairs(DescribeKeyPairsRequest describeKeyPairsRequest)` The DescribeKeyPairs operation returns information about key pairs available to you.
`DescribeLicensesResult` | `describeLicenses()` Provides details of a user's registered licenses.
`DescribeLicensesResult` | `describeLicenses(DescribeLicensesRequest describeLicensesRequest)` Provides details of a user's registered licenses.
`DescribePlacementGroupsResult` | `describePlacementGroups()` Returns information about one or more PlacementGroup instances in a user's account.
`DescribePlacementGroupsResult` | `describePlacementGroups(DescribePlacementGroupsRequest describePlacementGroupsRequest)` Returns information about one or more PlacementGroup instances in a user's account.
`DescribeRegionsResult` | `describeRegions()` The DescribeRegions operation describes regions zones that are currently available to the account.
`DescribeRegionsResult` | `describeRegions(DescribeRegionsRequest describeRegionsRequest)` The DescribeRegions operation describes regions zones that are currently available to the account.
`DescribeReservedInstancesResult` | `describeReservedInstances()` The DescribeReservedInstances operation describes Reserved Instances that were purchased for use with your account.
`DescribeReservedInstancesResult` | `describeReservedInstances(DescribeReservedInstancesRequest describeReservedInstancesRequest)` The DescribeReservedInstances operation describes Reserved Instances that were purchased for use with your account.
`DescribeReservedInstancesOfferingsResult` | `describeReservedInstancesOfferings()` The DescribeReservedInstancesOfferings operation describes Reserved Instance offerings that are available for purchase.
`DescribeReservedInstancesOfferingsResult` | `describeReservedInstancesOfferings(DescribeReservedInstancesOfferingsRequest describeReservedInstancesOfferingsRequest)` The DescribeReservedInstancesOfferings operation describes Reserved Instance offerings that are available for purchase.
`DescribeSecurityGroupsResult` | `describeSecurityGroups()` The DescribeSecurityGroups operation returns information about security groups that you own.
`DescribeSecurityGroupsResult` | `describeSecurityGroups(DescribeSecurityGroupsRequest describeSecurityGroupsRequest)` The DescribeSecurityGroups operation returns information about security groups that you own.
`DescribeSnapshotAttributeResult` | `describeSnapshotAttribute(DescribeSnapshotAttributeRequest describeSnapshotAttributeRequest)` Returns information about an attribute of a snapshot.
`DescribeSnapshotsResult` | `describeSnapshots()` Describes the indicated snapshots, or in lieu of that, all snapshots owned by the caller.
`DescribeSnapshotsResult` | `describeSnapshots(DescribeSnapshotsRequest describeSnapshotsRequest)` Describes the indicated snapshots, or in lieu of that, all snapshots owned by the caller.
`DescribeSpotDatafeedSubscriptionResult` | `describeSpotDatafeedSubscription()` Describes the data feed for Spot Instances.
`DescribeSpotDatafeedSubscriptionResult` | `describeSpotDatafeedSubscription(DescribeSpotDatafeedSubscriptionRequest describeSpotDatafeedSubscriptionRequest)` Describes the data feed for Spot Instances.
`DescribeSpotInstanceRequestsResult` | `describeSpotInstanceRequests()`
`DescribeSpotInstanceRequestsResult` | `describeSpotInstanceRequests(DescribeSpotInstanceRequestsRequest describeSpotInstanceRequestsRequest)`
`DescribeSpotPriceHistoryResult` | `describeSpotPriceHistory()` Describes the Spot Price history.
`DescribeSpotPriceHistoryResult` | `describeSpotPriceHistory(DescribeSpotPriceHistoryRequest describeSpotPriceHistoryRequest)` Describes the Spot Price history.
`DescribeSubnetsResult` | `describeSubnets()` Gives you information about your subnets.
`DescribeSubnetsResult` | `describeSubnets(DescribeSubnetsRequest describeSubnetsRequest)` Gives you information about your subnets.
`DescribeVolumesResult` | `describeVolumes(DescribeVolumesRequest describeVolumesRequest)` Describes the status of the indicated or, in lieu of any specified, all volumes belonging to the caller.
`DescribeVpcsResult` | `describeVpcs()` Gives you information about your VPCs.
`DescribeVpcsResult` | `describeVpcs(DescribeVpcsRequest describeVpcsRequest)` Gives you information about your VPCs.
`DescribeVpnConnectionsResult` | `describeVpnConnections()` Gives you information about your VPN connections.
`DescribeVpnConnectionsResult` | `describeVpnConnections(DescribeVpnConnectionsRequest describeVpnConnectionsRequest)` Gives you information about your VPN connections.
`DescribeVpnGatewaysResult` | `describeVpnGateways()` Gives you information about your VPN gateways.
`DescribeVpnGatewaysResult` | `describeVpnGateways(DescribeVpnGatewaysRequest describeVpnGatewaysRequest)` Gives you information about your VPN gateways.
`DetachVolumeResult` | `detachVolume(DetachVolumeRequest detachVolumeRequest)` Detach a previously attached volume from a running instance.
`void` | `detachVpnGateway(DetachVpnGatewayRequest detachVpnGatewayRequest)` Detaches a VPN gateway from a VPC.
`void` | `disassociateAddress(DisassociateAddressRequest disassociateAddressRequest)` The DisassociateAddress operation disassociates the specified elastic IP address from the instance to which it is assigned.
`GetConsoleOutputResult` | `getConsoleOutput(GetConsoleOutputRequest getConsoleOutputRequest)` The GetConsoleOutput operation retrieves console output for the specified instance.
`GetPasswordDataResult` | `getPasswordData(GetPasswordDataRequest getPasswordDataRequest)` Retrieves the encrypted administrator password for the instances running Windows.
`void` | `modifyImageAttribute(ModifyImageAttributeRequest modifyImageAttributeRequest)` The ModifyImageAttribute operation modifies an attribute of an AMI.
`void` | `modifyInstanceAttribute(ModifyInstanceAttributeRequest modifyInstanceAttributeRequest)` Modifies an attribute of an instance.
`void` | `modifySnapshotAttribute(ModifySnapshotAttributeRequest modifySnapshotAttributeRequest)` Adds or remove permission settings for the specified snapshot.
`MonitorInstancesResult` | `monitorInstances(MonitorInstancesRequest monitorInstancesRequest)` Enables monitoring for a running instance.
`PurchaseReservedInstancesOfferingResult` | `purchaseReservedInstancesOffering(PurchaseReservedInstancesOfferingRequest purchaseReservedInstancesOfferingRequest)` The PurchaseReservedInstancesOffering operation purchases a Reserved Instance for use with your account.
`void` | `rebootInstances(RebootInstancesRequest rebootInstancesRequest)` The RebootInstances operation requests a reboot of one or more instances.
`RegisterImageResult` | `registerImage(RegisterImageRequest registerImageRequest)` The RegisterImage operation registers an AMI with Amazon EC2.
`void` | `releaseAddress(ReleaseAddressRequest releaseAddressRequest)` The ReleaseAddress operation releases an elastic IP address associated with your account.
`RequestSpotInstancesResult` | `requestSpotInstances(RequestSpotInstancesRequest requestSpotInstancesRequest)` Creates a Spot Instance request.
`void` | `resetImageAttribute(ResetImageAttributeRequest resetImageAttributeRequest)` The ResetImageAttribute operation resets an attribute of an AMI to its default value.
`void` | `resetInstanceAttribute(ResetInstanceAttributeRequest resetInstanceAttributeRequest)` Resets an attribute of an instance to its default value.
`void` | `resetSnapshotAttribute(ResetSnapshotAttributeRequest resetSnapshotAttributeRequest)` Resets permission settings for the specified snapshot.
`void` | `revokeSecurityGroupIngress(RevokeSecurityGroupIngressRequest revokeSecurityGroupIngressRequest)` The RevokeSecurityGroupIngress operation revokes permissions from a security group.
`RunInstancesResult` | `runInstances(RunInstancesRequest runInstancesRequest)` The RunInstances operation launches a specified number of instances.
`StartInstancesResult` | `startInstances(StartInstancesRequest startInstancesRequest)` Starts an instance that uses an Amazon EBS volume as its root device.
`StopInstancesResult` | `stopInstances(StopInstancesRequest stopInstancesRequest)` Stops an instance that uses an Amazon EBS volume as its root device.
`TerminateInstancesResult` | `terminateInstances(TerminateInstancesRequest terminateInstancesRequest)` The TerminateInstances operation shuts down one or more instances.
`UnmonitorInstancesResult` | `unmonitorInstances(UnmonitorInstancesRequest unmonitorInstancesRequest)` Disables monitoring for a running instance.

Methods inherited from class com.amazonaws.AmazonWebServiceClient
`setEndpoint, shutdown`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.amazonaws.services.ec2.AmazonEC2
`setEndpoint, shutdown`

Constructor Detail

### AmazonEC2Client

    public AmazonEC2Client(AWSCredentials awsCredentials)

  Constructs a new client to invoke service methods on AmazonEC2 using the specified AWS account credentials.

  All service calls made using this new client object are blocking, and will not return until the service call completes.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.

### AmazonEC2Client

    public AmazonEC2Client(AWSCredentials awsCredentials,
                           ClientConfiguration clientConfiguration)

  Constructs a new client to invoke service methods on AmazonEC2 using the specified AWS account credentials and client configuration options.

  All service calls made using this new client object are blocking, and will not return until the service call completes.

  Parameters:
    `awsCredentials` - The AWS credentials (access key ID and secret key) to use when authenticating with AWS services.
    `clientConfiguration` - The client configuration options controlling how this client connects to AmazonEC2 (ex: proxy settings, retry counts, etc.).

Method Detail

### rebootInstances

    public void rebootInstances(RebootInstancesRequest rebootInstancesRequest)
                         throws AmazonServiceException,
                                AmazonClientException

  The RebootInstances operation requests a reboot of one or more instances. This operation is asynchronous; it only queues a request to reboot the specified instance(s). The operation will succeed if the instances are valid and belong to the user. Requests to reboot terminated instances are ignored.

  Specified by:
    `rebootInstances` in interface `AmazonEC2`
  Parameters:
    `rebootInstancesRequest` - Container for the necessary parameters to execute the RebootInstances service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describePlacementGroups

    public DescribePlacementGroupsResult describePlacementGroups(DescribePlacementGroupsRequest describePlacementGroupsRequest)
                                                          throws AmazonServiceException,
                                                                 AmazonClientException

  Returns information about one or more PlacementGroup instances in a user's account.

  Specified by:
    `describePlacementGroups` in interface `AmazonEC2`
  Parameters:
    `describePlacementGroupsRequest` - Container for the necessary parameters to execute the DescribePlacementGroups service method on AmazonEC2.
  Returns:
    The response from the DescribePlacementGroups service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### runInstances

    public RunInstancesResult runInstances(RunInstancesRequest runInstancesRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  The RunInstances operation launches a specified number of instances.

  If Amazon EC2 cannot launch the minimum number AMIs you request, no instances launch. If there is insufficient capacity to launch the maximum number of AMIs you request, Amazon EC2 launches as many as possible to satisfy the requested maximum values.

  Every instance is launched in a security group. If you do not specify a security group at launch, the instances start in your default security group. For more information on creating security groups, see CreateSecurityGroup.

  An optional instance type can be specified. For information about instance types, see Instance Types.

  You can provide an optional key pair ID for each image in the launch request (for more information, see CreateKeyPair). All instances that are created from images that use this key pair will have access to the associated public key at boot. You can use this key to provide secure access to an instance of an image on a per-instance basis. Amazon EC2 public images use this feature to provide secure access without passwords.

  IMPORTANT: Launching public images without a key pair ID will leave them inaccessible. The public key material is made available to the instance at boot time by placing it in the openssh_id.pub file on a logical device that is exposed to the instance as /dev/sda2 (the ephemeral store). The format of this file is suitable for use as an entry within ~/.ssh/authorized_keys (the OpenSSH format). This can be done at boot (e.g., as part of rc.local) allowing for secure access without passwords. Optional user data can be provided in the launch request. All instances that collectively comprise the launch request have access to this data For more information, see Instance Metadata.

  NOTE: If any of the AMIs have a product code attached for which the user has not subscribed, the RunInstances call will fail.

  IMPORTANT: We strongly recommend using the 2.6.18 Xen stock kernel with the c1.medium and c1.xlarge instances. Although the default Amazon EC2 kernels will work, the new kernels provide greater stability and performance for these instance types. For more information about kernels, see Kernels, RAM Disks, and Block Device Mappings.

  Specified by:
    `runInstances` in interface `AmazonEC2`
  Parameters:
    `runInstancesRequest` - Container for the necessary parameters to execute the RunInstances service method on AmazonEC2.
  Returns:
    The response from the RunInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeReservedInstances

    public DescribeReservedInstancesResult describeReservedInstances(DescribeReservedInstancesRequest describeReservedInstancesRequest)
                                                              throws AmazonServiceException,
                                                                     AmazonClientException

  The DescribeReservedInstances operation describes Reserved Instances that were purchased for use with your account.

  Specified by:
    `describeReservedInstances` in interface `AmazonEC2`
  Parameters:
    `describeReservedInstancesRequest` - Container for the necessary parameters to execute the DescribeReservedInstances service method on AmazonEC2.
  Returns:
    The response from the DescribeReservedInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSubnets

    public DescribeSubnetsResult describeSubnets(DescribeSubnetsRequest describeSubnetsRequest)
                                          throws AmazonServiceException,
                                                 AmazonClientException

  Gives you information about your subnets. You can filter the results to return information only about subnets that match criteria you specify. For example, you could ask to get information about a particular subnet (or all) only if the subnet's state is available. You can specify multiple filters (e.g., the subnet is in a particular VPC, and the subnet's state is available). The result includes information for a particular subnet only if the subnet matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeSubnets` in interface `AmazonEC2`
  Parameters:
    `describeSubnetsRequest` - Container for the necessary parameters to execute the DescribeSubnets service method on AmazonEC2.
  Returns:
    The response from the DescribeSubnets service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeAvailabilityZones

    public DescribeAvailabilityZonesResult describeAvailabilityZones(DescribeAvailabilityZonesRequest describeAvailabilityZonesRequest)
                                                              throws AmazonServiceException,
                                                                     AmazonClientException

  The DescribeAvailabilityZones operation describes availability zones that are currently available to the account and their states.

  Availability zones are not the same across accounts. The availability zone us-east-1a for account A is not necessarily the same as us-east-1a for account B. Zone assignments are mapped independently for each account.

  Specified by:
    `describeAvailabilityZones` in interface `AmazonEC2`
  Parameters:
    `describeAvailabilityZonesRequest` - Container for the necessary parameters to execute the DescribeAvailabilityZones service method on AmazonEC2.
  Returns:
    The response from the DescribeAvailabilityZones service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### detachVolume

    public DetachVolumeResult detachVolume(DetachVolumeRequest detachVolumeRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  Detach a previously attached volume from a running instance.

  Specified by:
    `detachVolume` in interface `AmazonEC2`
  Parameters:
    `detachVolumeRequest` - Container for the necessary parameters to execute the DetachVolume service method on AmazonEC2.
  Returns:
    The response from the DetachVolume service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteKeyPair

    public void deleteKeyPair(DeleteKeyPairRequest deleteKeyPairRequest)
                       throws AmazonServiceException,
                              AmazonClientException

  The DeleteKeyPair operation deletes a key pair.

  Specified by:
    `deleteKeyPair` in interface `AmazonEC2`
  Parameters:
    `deleteKeyPairRequest` - Container for the necessary parameters to execute the DeleteKeyPair service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeInstances

    public DescribeInstancesResult describeInstances(DescribeInstancesRequest describeInstancesRequest)
                                              throws AmazonServiceException,
                                                     AmazonClientException

  The DescribeInstances operation returns information about instances that you own.

  If you specify one or more instance IDs, Amazon EC2 returns information for those instances. If you do not specify instance IDs, Amazon EC2 returns information for all relevant instances. If you specify an invalid instance ID, a fault is returned. If you specify an instance that you do not own, it will not be included in the returned results.

  Recently terminated instances might appear in the returned results. This interval is usually less than one hour.

  Specified by:
    `describeInstances` in interface `AmazonEC2`
  Parameters:
    `describeInstancesRequest` - Container for the necessary parameters to execute the DescribeInstances service method on AmazonEC2.
  Returns:
    The response from the DescribeInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeImages

    public DescribeImagesResult describeImages(DescribeImagesRequest describeImagesRequest)
                                        throws AmazonServiceException,
                                               AmazonClientException

  The DescribeImages operation returns information about AMIs, AKIs, and ARIs available to the user. Information returned includes image type, product codes, architecture, and kernel and RAM disk IDs. Images available to the user include public images available for any user to launch, private images owned by the user making the request, and private images owned by other users for which the user has explicit launch permissions.

  Launch permissions fall into three categories:

  - Public: The owner of the AMI granted launch permissions for the AMI to the all group. All users have launch permissions for these AMIs.
  - Explicit: The owner of the AMI granted launch permissions to a specific user.
  - Implicit: A user has implicit launch permissions for all AMIs he or she owns.

  The list of AMIs returned can be modified by specifying AMI IDs, AMI owners, or users with launch permissions. If no options are specified, Amazon EC2 returns all AMIs for which the user has launch permissions.

  If you specify one or more AMI IDs, only AMIs that have the specified IDs are returned. If you specify an invalid AMI ID, a fault is returned. If you specify an AMI ID for which you do not have access, it will not be included in the returned results.

  If you specify one or more AMI owners, only AMIs from the specified owners and for which you have access are returned. The results can include the account IDs of the specified owners, amazon for AMIs owned by Amazon or self for AMIs that you own.

  If you specify a list of executable users, only users that have launch permissions for the AMIs are returned. You can specify account IDs (if you own the AMI(s)), self for AMIs for which you own or have explicit permissions, or all for public AMIs.

  NOTE: Deregistered images are included in the returned results for an unspecified interval after deregistration.

  Specified by:
    `describeImages` in interface `AmazonEC2`
  Parameters:
    `describeImagesRequest` - Container for the necessary parameters to execute the DescribeImages service method on AmazonEC2.
  Returns:
    The response from the DescribeImages service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### startInstances

    public StartInstancesResult startInstances(StartInstancesRequest startInstancesRequest)
                                        throws AmazonServiceException,
                                               AmazonClientException

  Starts an instance that uses an Amazon EBS volume as its root device. Instances that use Amazon EBS volumes as their root devices can be quickly stopped and started. When an instance is stopped, the compute resources are released and you are not billed for hourly instance usage. However, your root partition Amazon EBS volume remains, continues to persist your data, and you are charged for Amazon EBS volume usage. You can restart your instance at any time.

  NOTE: Before stopping an instance, make sure it is in a state from which it can be restarted. Stopping an instance does not preserve data stored in RAM. Performing this operation on an instance that uses an instance store as its root device returns an error.

  Specified by:
    `startInstances` in interface `AmazonEC2`
  Parameters:
    `startInstancesRequest` - Container for the necessary parameters to execute the StartInstances service method on AmazonEC2.
  Returns:
    The response from the StartInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### unmonitorInstances

    public UnmonitorInstancesResult unmonitorInstances(UnmonitorInstancesRequest unmonitorInstancesRequest)
                                                throws AmazonServiceException,
                                                       AmazonClientException

  Disables monitoring for a running instance.

  Specified by:
    `unmonitorInstances` in interface `AmazonEC2`
  Parameters:
    `unmonitorInstancesRequest` - Container for the necessary parameters to execute the UnmonitorInstances service method on AmazonEC2.
  Returns:
    The response from the UnmonitorInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### attachVpnGateway

    public AttachVpnGatewayResult attachVpnGateway(AttachVpnGatewayRequest attachVpnGatewayRequest)
                                            throws AmazonServiceException,
                                                   AmazonClientException

  Attaches a VPN gateway to a VPC. This is the last step required to get your VPC fully connected to your data center before launching instances in it. For more information, go to Process for Using Amazon VPC in the Amazon Virtual Private Cloud Developer Guide.

  Specified by:
    `attachVpnGateway` in interface `AmazonEC2`
  Parameters:
    `attachVpnGatewayRequest` - Container for the necessary parameters to execute the AttachVpnGateway service method on AmazonEC2.
  Returns:
    The response from the AttachVpnGateway service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### modifyInstanceAttribute

    public void modifyInstanceAttribute(ModifyInstanceAttributeRequest modifyInstanceAttributeRequest)
                                 throws AmazonServiceException,
                                        AmazonClientException

  Modifies an attribute of an instance.

  Specified by:
    `modifyInstanceAttribute` in interface `AmazonEC2`
  Parameters:
    `modifyInstanceAttributeRequest` - Container for the necessary parameters to execute the ModifyInstanceAttribute service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteDhcpOptions

    public void deleteDhcpOptions(DeleteDhcpOptionsRequest deleteDhcpOptionsRequest)
                           throws AmazonServiceException,
                                  AmazonClientException

  Deletes a set of DHCP options that you specify. Amazon VPC returns an error if the set of options you specify is currently associated with a VPC. You can disassociate the set of options by associating either a new set of options or the default options with the VPC.

  Specified by:
    `deleteDhcpOptions` in interface `AmazonEC2`
  Parameters:
    `deleteDhcpOptionsRequest` - Container for the necessary parameters to execute the DeleteDhcpOptions service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteSecurityGroup

    public void deleteSecurityGroup(DeleteSecurityGroupRequest deleteSecurityGroupRequest)
                             throws AmazonServiceException,
                                    AmazonClientException

  The DeleteSecurityGroup operation deletes a security group.

  NOTE: If you attempt to delete a security group that contains instances, a fault is returned. If you attempt to delete a security group that is referenced by another security group, a fault is returned. For example, if security group B has a rule that allows access from security group A, security group A cannot be deleted until the allow rule is removed.

  Specified by:
    `deleteSecurityGroup` in interface `AmazonEC2`
  Parameters:
    `deleteSecurityGroupRequest` - Container for the necessary parameters to execute the DeleteSecurityGroup service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createImage

    public CreateImageResult createImage(CreateImageRequest createImageRequest)
                                  throws AmazonServiceException,
                                         AmazonClientException

  Creates an AMI that uses an Amazon EBS root device from a "running" or "stopped" instance. AMIs that use an Amazon EBS root device boot faster than AMIs that use instance stores. They can be up to 1 TiB in size, use storage that persists on instance failure, and can be stopped and started.

  Specified by:
    `createImage` in interface `AmazonEC2`
  Parameters:
    `createImageRequest` - Container for the necessary parameters to execute the CreateImage service method on AmazonEC2.
  Returns:
    The response from the CreateImage service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### authorizeSecurityGroupIngress

    public void authorizeSecurityGroupIngress(AuthorizeSecurityGroupIngressRequest authorizeSecurityGroupIngressRequest)
                                       throws AmazonServiceException,
                                              AmazonClientException

  The AuthorizeSecurityGroupIngress operation adds permissions to a security group.

  Permissions are specified by the IP protocol (TCP, UDP or ICMP), the source of the request (by IP range or an Amazon EC2 user-group pair), the source and destination port ranges (for TCP and UDP), and the ICMP codes and types (for ICMP). When authorizing ICMP, -1 can be used as a wildcard in the type and code fields.

  Permission changes are propagated to instances within the security group as quickly as possible. However, depending on the number of instances, a small delay might occur.

  When authorizing a user/group pair permission, GroupName, SourceSecurityGroupName and SourceSecurityGroupOwnerId must be specified. When authorizing a CIDR IP permission, GroupName, IpProtocol, FromPort, ToPort and CidrIp must be specified. Mixing these two types of parameters is not allowed.

  Specified by:
    `authorizeSecurityGroupIngress` in interface `AmazonEC2`
  Parameters:
    `authorizeSecurityGroupIngressRequest` - Container for the necessary parameters to execute the AuthorizeSecurityGroupIngress service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSpotInstanceRequests

    public DescribeSpotInstanceRequestsResult describeSpotInstanceRequests(DescribeSpotInstanceRequestsRequest describeSpotInstanceRequestsRequest)
                                                                    throws AmazonServiceException,
                                                                           AmazonClientException

  Specified by:
    `describeSpotInstanceRequests` in interface `AmazonEC2`
  Parameters:
    `describeSpotInstanceRequestsRequest` - Container for the necessary parameters to execute the DescribeSpotInstanceRequests service method on AmazonEC2.
  Returns:
    The response from the DescribeSpotInstanceRequests service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### associateDhcpOptions

    public void associateDhcpOptions(AssociateDhcpOptionsRequest associateDhcpOptionsRequest)
                              throws AmazonServiceException,
                                     AmazonClientException

  Associates a set of DHCP options (that you've previously created) with the specified VPC. Or, associates the default DHCP options with the VPC. The default set consists of the standard EC2 host name, no domain name, no DNS server, no NTP server, and no NetBIOS server or node type. After you associate the options with the VPC, any existing instances and all new instances that you launch in that VPC use the options. For more information about the supported DHCP options and using them with Amazon VPC, go to Using DHCP Options in the Amazon Virtual Private Cloud Developer Guide.

  Specified by:
    `associateDhcpOptions` in interface `AmazonEC2`
  Parameters:
    `associateDhcpOptionsRequest` - Container for the necessary parameters to execute the AssociateDhcpOptions service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### getPasswordData

    public GetPasswordDataResult getPasswordData(GetPasswordDataRequest getPasswordDataRequest)
                                          throws AmazonServiceException,
                                                 AmazonClientException

  Retrieves the encrypted administrator password for the instances running Windows.

  NOTE: The Windows password is only generated the first time an AMI is launched. It is not generated for rebundled AMIs or after the password is changed on an instance. The password is encrypted using the key pair that you provided.

  Specified by:
    `getPasswordData` in interface `AmazonEC2`
  Parameters:
    `getPasswordDataRequest` - Container for the necessary parameters to execute the GetPasswordData service method on AmazonEC2.
  Returns:
    The response from the GetPasswordData service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createVpc

    public CreateVpcResult createVpc(CreateVpcRequest createVpcRequest)
                              throws AmazonServiceException,
                                     AmazonClientException

  Creates a VPC with the CIDR block you specify. The smallest VPC you can create uses a /28 netmask (16 IP addresses), and the largest uses a /18 netmask (16,384 IP addresses). To help you decide how big to make your VPC, go to the topic about creating VPCs in the Amazon Virtual Private Cloud Developer Guide.

  By default, each instance you launch in the VPC has the default DHCP options (the standard EC2 host name, no domain name, no DNS server, no NTP server, and no NetBIOS server or node type).

  Specified by:
    `createVpc` in interface `AmazonEC2`
  Parameters:
    `createVpcRequest` - Container for the necessary parameters to execute the CreateVpc service method on AmazonEC2.
  Returns:
    The response from the CreateVpc service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### stopInstances

    public StopInstancesResult stopInstances(StopInstancesRequest stopInstancesRequest)
                                      throws AmazonServiceException,
                                             AmazonClientException

  Stops an instance that uses an Amazon EBS volume as its root device. Instances that use Amazon EBS volumes as their root devices can be quickly stopped and started. When an instance is stopped, the compute resources are released and you are not billed for hourly instance usage. However, your root partition Amazon EBS volume remains, continues to persist your data, and you are charged for Amazon EBS volume usage. You can restart your instance at any time.

  NOTE: Before stopping an instance, make sure it is in a state from which it can be restarted. Stopping an instance does not preserve data stored in RAM. Performing this operation on an instance that uses an instance store as its root device returns an error.

  Specified by:
    `stopInstances` in interface `AmazonEC2`
  Parameters:
    `stopInstancesRequest` - Container for the necessary parameters to execute the StopInstances service method on AmazonEC2.
  Returns:
    The response from the StopInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeCustomerGateways

    public DescribeCustomerGatewaysResult describeCustomerGateways(DescribeCustomerGatewaysRequest describeCustomerGatewaysRequest)
                                                            throws AmazonServiceException,
                                                                   AmazonClientException

  Gives you information about your customer gateways. You can filter the results to return information only about customer gateways that match criteria you specify. For example, you could ask to get information about a particular customer gateway (or all) only if the gateway's state is pending or available. You can specify multiple filters (e.g., the customer gateway has a particular IP address for the Internet-routable external interface, and the gateway's state is pending or available). The result includes information for a particular customer gateway only if the gateway matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeCustomerGateways` in interface `AmazonEC2`
  Parameters:
    `describeCustomerGatewaysRequest` - Container for the necessary parameters to execute the DescribeCustomerGateways service method on AmazonEC2.
  Returns:
    The response from the DescribeCustomerGateways service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSpotPriceHistory

    public DescribeSpotPriceHistoryResult describeSpotPriceHistory(DescribeSpotPriceHistoryRequest describeSpotPriceHistoryRequest)
                                                            throws AmazonServiceException,
                                                                   AmazonClientException

  Describes the Spot Price history.

  Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that you specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based on available Spot Instance capacity and current spot instance requests.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `describeSpotPriceHistory` in interface `AmazonEC2`
  Parameters:
    `describeSpotPriceHistoryRequest` - Container for the necessary parameters to execute the DescribeSpotPriceHistory service method on AmazonEC2.
  Returns:
    The response from the DescribeSpotPriceHistory service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createSecurityGroup

    public void createSecurityGroup(CreateSecurityGroupRequest createSecurityGroupRequest)
                             throws AmazonServiceException,
                                    AmazonClientException

  The CreateSecurityGroup operation creates a new security group.

  Every instance is launched in a security group. If no security group is specified during launch, the instances are launched in the default security group. Instances within the same security group have unrestricted network access to each other. Instances will reject network access attempts from other instances in a different security group. As the owner of instances you can grant or revoke specific permissions using the AuthorizeSecurityGroupIngress and RevokeSecurityGroupIngress operations.

  Specified by:
    `createSecurityGroup` in interface `AmazonEC2`
  Parameters:
    `createSecurityGroupRequest` - Container for the necessary parameters to execute the CreateSecurityGroup service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeRegions

    public DescribeRegionsResult describeRegions(DescribeRegionsRequest describeRegionsRequest)
                                          throws AmazonServiceException,
                                                 AmazonClientException

  The DescribeRegions operation describes regions zones that are currently available to the account.

  Specified by:
    `describeRegions` in interface `AmazonEC2`
  Parameters:
    `describeRegionsRequest` - Container for the necessary parameters to execute the DescribeRegions service method on AmazonEC2.
  Returns:
    The response from the DescribeRegions service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createDhcpOptions

    public CreateDhcpOptionsResult createDhcpOptions(CreateDhcpOptionsRequest createDhcpOptionsRequest)
                                              throws AmazonServiceException,
                                                     AmazonClientException

  Creates a set of DHCP options that you can then associate with one or more VPCs, causing all existing and new instances that you launch in those VPCs to use the set of DHCP options. The following table lists the individual DHCP options you can specify. For more information about the options, go to http://www.ietf.org/rfc/rfc2132.txt

  Specified by:
    `createDhcpOptions` in interface `AmazonEC2`
  Parameters:
    `createDhcpOptionsRequest` - Container for the necessary parameters to execute the CreateDhcpOptions service method on AmazonEC2.
  Returns:
    The response from the CreateDhcpOptions service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### resetSnapshotAttribute

    public void resetSnapshotAttribute(ResetSnapshotAttributeRequest resetSnapshotAttributeRequest)
                                throws AmazonServiceException,
                                       AmazonClientException

  Resets permission settings for the specified snapshot.

  Specified by:
    `resetSnapshotAttribute` in interface `AmazonEC2`
  Parameters:
    `resetSnapshotAttributeRequest` - Container for the necessary parameters to execute the ResetSnapshotAttribute service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSecurityGroups

    public DescribeSecurityGroupsResult describeSecurityGroups(DescribeSecurityGroupsRequest describeSecurityGroupsRequest)
                                                        throws AmazonServiceException,
                                                               AmazonClientException

  The DescribeSecurityGroups operation returns information about security groups that you own.

  If you specify security group names, information about those security group is returned. Otherwise, information for all security group is returned. If you specify a group that does not exist, a fault is returned.

  Specified by:
    `describeSecurityGroups` in interface `AmazonEC2`
  Parameters:
    `describeSecurityGroupsRequest` - Container for the necessary parameters to execute the DescribeSecurityGroups service method on AmazonEC2.
  Returns:
    The response from the DescribeSecurityGroups service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### requestSpotInstances

    public RequestSpotInstancesResult requestSpotInstances(RequestSpotInstancesRequest requestSpotInstancesRequest)
                                                    throws AmazonServiceException,
                                                           AmazonClientException

  Creates a Spot Instance request.

  Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that you specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based on available Spot Instance capacity and current spot instance requests.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide.

  Specified by:
    `requestSpotInstances` in interface `AmazonEC2`
  Parameters:
    `requestSpotInstancesRequest` - Container for the necessary parameters to execute the RequestSpotInstances service method on AmazonEC2.
  Returns:
    The response from the RequestSpotInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### detachVpnGateway

    public void detachVpnGateway(DetachVpnGatewayRequest detachVpnGatewayRequest)
                          throws AmazonServiceException,
                                 AmazonClientException

  Detaches a VPN gateway from a VPC. You do this if you're planning to turn off the VPC and not use it anymore. You can confirm a VPN gateway has been completely detached from a VPC by describing the VPN gateway (any attachments to the VPN gateway are also described).

  You must wait for the attachment's state to switch to detached before you can delete the VPC or attach a different VPC to the VPN gateway.

  Specified by:
    `detachVpnGateway` in interface `AmazonEC2`
  Parameters:
    `detachVpnGatewayRequest` - Container for the necessary parameters to execute the DetachVpnGateway service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deregisterImage

    public void deregisterImage(DeregisterImageRequest deregisterImageRequest)
                         throws AmazonServiceException,
                                AmazonClientException

  The DeregisterImage operation deregisters an AMI. Once deregistered, instances of the AMI can no longer be launched.

  Specified by:
    `deregisterImage` in interface `AmazonEC2`
  Parameters:
    `deregisterImageRequest` - Container for the necessary parameters to execute the DeregisterImage service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSpotDatafeedSubscription

    public DescribeSpotDatafeedSubscriptionResult describeSpotDatafeedSubscription(DescribeSpotDatafeedSubscriptionRequest describeSpotDatafeedSubscriptionRequest)
                                                                            throws AmazonServiceException,
                                                                                   AmazonClientException

  Describes the data feed for Spot Instances.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `describeSpotDatafeedSubscription` in interface `AmazonEC2`
  Parameters:
    `describeSpotDatafeedSubscriptionRequest` - Container for the necessary parameters to execute the DescribeSpotDatafeedSubscription service method on AmazonEC2.
  Returns:
    The response from the DescribeSpotDatafeedSubscription service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteSubnet

    public void deleteSubnet(DeleteSubnetRequest deleteSubnetRequest)
                      throws AmazonServiceException,
                             AmazonClientException

  Deletes a subnet from a VPC. You must terminate all running instances in the subnet before deleting it, otherwise Amazon VPC returns an error.

  Specified by:
    `deleteSubnet` in interface `AmazonEC2`
  Parameters:
    `deleteSubnetRequest` - Container for the necessary parameters to execute the DeleteSubnet service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createVpnGateway

    public CreateVpnGatewayResult createVpnGateway(CreateVpnGatewayRequest createVpnGatewayRequest)
                                            throws AmazonServiceException,
                                                   AmazonClientException

  Creates a new VPN gateway. A VPN gateway is the VPC-side endpoint for your VPN connection. You can create a VPN gateway before creating the VPC itself.

  Specified by:
    `createVpnGateway` in interface `AmazonEC2`
  Parameters:
    `createVpnGatewayRequest` - Container for the necessary parameters to execute the CreateVpnGateway service method on AmazonEC2.
  Returns:
    The response from the CreateVpnGateway service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### cancelBundleTask

    public CancelBundleTaskResult cancelBundleTask(CancelBundleTaskRequest cancelBundleTaskRequest)
                                            throws AmazonServiceException,
                                                   AmazonClientException

  CancelBundleTask operation cancels a pending or in-progress bundling task. This is an asynchronous call and it make take a while for the task to be canceled. If a task is canceled while it is storing items, there may be parts of the incomplete AMI stored in S3. It is up to the caller to clean up these parts from S3.

  Specified by:
    `cancelBundleTask` in interface `AmazonEC2`
  Parameters:
    `cancelBundleTaskRequest` - Container for the necessary parameters to execute the CancelBundleTask service method on AmazonEC2.
  Returns:
    The response from the CancelBundleTask service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteVpnGateway

    public void deleteVpnGateway(DeleteVpnGatewayRequest deleteVpnGatewayRequest)
                          throws AmazonServiceException,
                                 AmazonClientException

  Deletes a VPN gateway. Use this when you want to delete a VPC and all its associated components because you no longer need them. We recommend that before you delete a VPN gateway, you detach it from the VPC and delete the VPN connection. Note that you don't need to delete the VPN gateway if you just want to delete and re-create the VPN connection between your VPC and data center.

  Specified by:
    `deleteVpnGateway` in interface `AmazonEC2`
  Parameters:
    `deleteVpnGatewayRequest` - Container for the necessary parameters to execute the DeleteVpnGateway service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### cancelSpotInstanceRequests

    public CancelSpotInstanceRequestsResult cancelSpotInstanceRequests(CancelSpotInstanceRequestsRequest cancelSpotInstanceRequestsRequest)
                                                                throws AmazonServiceException,
                                                                       AmazonClientException

  Cancels one or more Spot Instance requests.

  Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that you specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based on available Spot Instance capacity and current spot instance requests.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `cancelSpotInstanceRequests` in interface `AmazonEC2`
  Parameters:
    `cancelSpotInstanceRequestsRequest` - Container for the necessary parameters to execute the CancelSpotInstanceRequests service method on AmazonEC2.
  Returns:
    The response from the CancelSpotInstanceRequests service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### attachVolume

    public AttachVolumeResult attachVolume(AttachVolumeRequest attachVolumeRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  Attach a previously created volume to a running instance.

  Specified by:
    `attachVolume` in interface `AmazonEC2`
  Parameters:
    `attachVolumeRequest` - Container for the necessary parameters to execute the AttachVolume service method on AmazonEC2.
  Returns:
    The response from the AttachVolume service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeLicenses

    public DescribeLicensesResult describeLicenses(DescribeLicensesRequest describeLicensesRequest)
                                            throws AmazonServiceException,
                                                   AmazonClientException

  Provides details of a user's registered licenses. Zero or more IDs may be specified on the call. When one or more license IDs are specified, only data for the specified IDs are returned.

  Specified by:
    `describeLicenses` in interface `AmazonEC2`
  Parameters:
    `describeLicensesRequest` - Container for the necessary parameters to execute the DescribeLicenses service method on AmazonEC2.
  Returns:
    The response from the DescribeLicenses service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### purchaseReservedInstancesOffering

    public PurchaseReservedInstancesOfferingResult purchaseReservedInstancesOffering(PurchaseReservedInstancesOfferingRequest purchaseReservedInstancesOfferingRequest)
                                                                              throws AmazonServiceException,
                                                                                     AmazonClientException

  The PurchaseReservedInstancesOffering operation purchases a Reserved Instance for use with your account. With Amazon EC2 Reserved Instances, you purchase the right to launch Amazon EC2 instances for a period of time (without getting insufficient capacity errors) and pay a lower usage rate for the actual time used.

  Specified by:
    `purchaseReservedInstancesOffering` in interface `AmazonEC2`
  Parameters:
    `purchaseReservedInstancesOfferingRequest` - Container for the necessary parameters to execute the PurchaseReservedInstancesOffering service method on AmazonEC2.
  Returns:
    The response from the PurchaseReservedInstancesOffering service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### activateLicense

    public void activateLicense(ActivateLicenseRequest activateLicenseRequest)
                         throws AmazonServiceException,
                                AmazonClientException

  Activates a specific number of licenses for a 90-day period. Activations can be done against a specific license ID.

  Specified by:
    `activateLicense` in interface `AmazonEC2`
  Parameters:
    `activateLicenseRequest` - Container for the necessary parameters to execute the ActivateLicense service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### resetImageAttribute

    public void resetImageAttribute(ResetImageAttributeRequest resetImageAttributeRequest)
                             throws AmazonServiceException,
                                    AmazonClientException

  The ResetImageAttribute operation resets an attribute of an AMI to its default value.

  NOTE: The productCodes attribute cannot be reset.

  Specified by:
    `resetImageAttribute` in interface `AmazonEC2`
  Parameters:
    `resetImageAttributeRequest` - Container for the necessary parameters to execute the ResetImageAttribute service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeVpnConnections

    public DescribeVpnConnectionsResult describeVpnConnections(DescribeVpnConnectionsRequest describeVpnConnectionsRequest)
                                                        throws AmazonServiceException,
                                                               AmazonClientException

  Gives you information about your VPN connections.

  IMPORTANT: We strongly recommend you use HTTPS when calling this operation because the response contains sensitive cryptographic information for configuring your customer gateway. You can filter the results to return information only about VPN connections that match criteria you specify. For example, you could ask to get information about a particular VPN connection (or all) only if the VPN's state is pending or available. You can specify multiple filters (e.g., the VPN connection is associated with a particular VPN gateway, and the gateway's state is pending or available). The result includes information for a particular VPN connection only if the VPN connection matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeVpnConnections` in interface `AmazonEC2`
  Parameters:
    `describeVpnConnectionsRequest` - Container for the necessary parameters to execute the DescribeVpnConnections service method on AmazonEC2.
  Returns:
    The response from the DescribeVpnConnections service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createSnapshot

    public CreateSnapshotResult createSnapshot(CreateSnapshotRequest createSnapshotRequest)
                                        throws AmazonServiceException,
                                               AmazonClientException

  Create a snapshot of the volume identified by volume ID. A volume does not have to be detached at the time the snapshot is taken.

  NOTE: Snapshot creation requires that the system is in a consistent state. For instance, this means that if taking a snapshot of a database, the tables must be read-only locked to ensure that the snapshot will not contain a corrupted version of the database. Therefore, be careful when using this API to ensure that the system remains in the consistent state until the create snapshot status has returned.

  Specified by:
    `createSnapshot` in interface `AmazonEC2`
  Parameters:
    `createSnapshotRequest` - Container for the necessary parameters to execute the CreateSnapshot service method on AmazonEC2.
  Returns:
    The response from the CreateSnapshot service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteVolume

    public void deleteVolume(DeleteVolumeRequest deleteVolumeRequest)
                      throws AmazonServiceException,
                             AmazonClientException

  Deletes a previously created volume. Once successfully deleted, a new volume can be created with the same name.

  Specified by:
    `deleteVolume` in interface `AmazonEC2`
  Parameters:
    `deleteVolumeRequest` - Container for the necessary parameters to execute the DeleteVolume service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### modifySnapshotAttribute

    public void modifySnapshotAttribute(ModifySnapshotAttributeRequest modifySnapshotAttributeRequest)
                                 throws AmazonServiceException,
                                        AmazonClientException

  Adds or remove permission settings for the specified snapshot.

  Specified by:
    `modifySnapshotAttribute` in interface `AmazonEC2`
  Parameters:
    `modifySnapshotAttributeRequest` - Container for the necessary parameters to execute the ModifySnapshotAttribute service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### terminateInstances

    public TerminateInstancesResult terminateInstances(TerminateInstancesRequest terminateInstancesRequest)
                                                throws AmazonServiceException,
                                                       AmazonClientException

  The TerminateInstances operation shuts down one or more instances. This operation is idempotent; if you terminate an instance more than once, each call will succeed.

  Terminated instances will remain visible after termination (approximately one hour).

  Specified by:
    `terminateInstances` in interface `AmazonEC2`
  Parameters:
    `terminateInstancesRequest` - Container for the necessary parameters to execute the TerminateInstances service method on AmazonEC2.
  Returns:
    The response from the TerminateInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteSpotDatafeedSubscription

    public void deleteSpotDatafeedSubscription(DeleteSpotDatafeedSubscriptionRequest deleteSpotDatafeedSubscriptionRequest)
                                        throws AmazonServiceException,
                                               AmazonClientException

  Deletes the data feed for Spot Instances.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `deleteSpotDatafeedSubscription` in interface `AmazonEC2`
  Parameters:
    `deleteSpotDatafeedSubscriptionRequest` - Container for the necessary parameters to execute the DeleteSpotDatafeedSubscription service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeVpcs

    public DescribeVpcsResult describeVpcs(DescribeVpcsRequest describeVpcsRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  Gives you information about your VPCs. You can filter the results to return information only about VPCs that match criteria you specify. For example, you could ask to get information about a particular VPC or VPCs (or all your VPCs) only if the VPC's state is available. You can specify multiple filters (e.g., the VPC uses one of several sets of DHCP options, and the VPC's state is available). The result includes information for a particular VPC only if the VPC matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeVpcs` in interface `AmazonEC2`
  Parameters:
    `describeVpcsRequest` - Container for the necessary parameters to execute the DescribeVpcs service method on AmazonEC2.
  Returns:
    The response from the DescribeVpcs service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### associateAddress

    public void associateAddress(AssociateAddressRequest associateAddressRequest)
                          throws AmazonServiceException,
                                 AmazonClientException

  The AssociateAddress operation associates an elastic IP address with an instance.

  If the IP address is currently assigned to another instance, the IP address is assigned to the new instance. This is an idempotent operation. If you enter it more than once, Amazon EC2 does not return an error.

  Specified by:
    `associateAddress` in interface `AmazonEC2`
  Parameters:
    `associateAddressRequest` - Container for the necessary parameters to execute the AssociateAddress service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deactivateLicense

    public void deactivateLicense(DeactivateLicenseRequest deactivateLicenseRequest)
                           throws AmazonServiceException,
                                  AmazonClientException

  Deactivates a specific number of licenses. Deactivations can be done against a specific license ID after they have persisted for at least a 90-day period.

  Specified by:
    `deactivateLicense` in interface `AmazonEC2`
  Parameters:
    `deactivateLicenseRequest` - Container for the necessary parameters to execute the DeactivateLicense service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSnapshotAttribute

    public DescribeSnapshotAttributeResult describeSnapshotAttribute(DescribeSnapshotAttributeRequest describeSnapshotAttributeRequest)
                                                              throws AmazonServiceException,
                                                                     AmazonClientException

  Returns information about an attribute of a snapshot. Only one attribute can be specified per call.

  Specified by:
    `describeSnapshotAttribute` in interface `AmazonEC2`
  Parameters:
    `describeSnapshotAttributeRequest` - Container for the necessary parameters to execute the DescribeSnapshotAttribute service method on AmazonEC2.
  Returns:
    The response from the DescribeSnapshotAttribute service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteCustomerGateway

    public void deleteCustomerGateway(DeleteCustomerGatewayRequest deleteCustomerGatewayRequest)
                               throws AmazonServiceException,
                                      AmazonClientException

  Deletes a customer gateway. You must delete the VPN connection before deleting the customer gateway.

  You can have a single active customer gateway per AWS account (active means that you've created a VPN connection with that customer gateway). AWS might delete any customer gateway you leave inactive for an extended period of time.

  Specified by:
    `deleteCustomerGateway` in interface `AmazonEC2`
  Parameters:
    `deleteCustomerGatewayRequest` - Container for the necessary parameters to execute the DeleteCustomerGateway service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeAddresses

    public DescribeAddressesResult describeAddresses(DescribeAddressesRequest describeAddressesRequest)
                                              throws AmazonServiceException,
                                                     AmazonClientException

  The DescribeAddresses operation lists elastic IP addresses assigned to your account.

  Specified by:
    `describeAddresses` in interface `AmazonEC2`
  Parameters:
    `describeAddressesRequest` - Container for the necessary parameters to execute the DescribeAddresses service method on AmazonEC2.
  Returns:
    The response from the DescribeAddresses service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeKeyPairs

    public DescribeKeyPairsResult describeKeyPairs(DescribeKeyPairsRequest describeKeyPairsRequest)
                                            throws AmazonServiceException,
                                                   AmazonClientException

  The DescribeKeyPairs operation returns information about key pairs available to you. If you specify key pairs, information about those key pairs is returned. Otherwise, information for all registered key pairs is returned.

  Specified by:
    `describeKeyPairs` in interface `AmazonEC2`
  Parameters:
    `describeKeyPairsRequest` - Container for the necessary parameters to execute the DescribeKeyPairs service method on AmazonEC2.
  Returns:
    The response from the DescribeKeyPairs service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeImageAttribute

    public DescribeImageAttributeResult describeImageAttribute(DescribeImageAttributeRequest describeImageAttributeRequest)
                                                        throws AmazonServiceException,
                                                               AmazonClientException

  The DescribeImageAttribute operation returns information about an attribute of an AMI. Only one attribute can be specified per call.

  Specified by:
    `describeImageAttribute` in interface `AmazonEC2`
  Parameters:
    `describeImageAttributeRequest` - Container for the necessary parameters to execute the DescribeImageAttribute service method on AmazonEC2.
  Returns:
    The response from the DescribeImageAttribute service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### confirmProductInstance

    public ConfirmProductInstanceResult confirmProductInstance(ConfirmProductInstanceRequest confirmProductInstanceRequest)
                                                        throws AmazonServiceException,
                                                               AmazonClientException

  The ConfirmProductInstance operation returns true if the specified product code is attached to the specified instance. The operation returns false if the product code is not attached to the instance.

  The ConfirmProductInstance operation can only be executed by the owner of the AMI. This feature is useful when an AMI owner is providing support and wants to verify whether a user's instance is eligible.

  Specified by:
    `confirmProductInstance` in interface `AmazonEC2`
  Parameters:
    `confirmProductInstanceRequest` - Container for the necessary parameters to execute the ConfirmProductInstance service method on AmazonEC2.
  Returns:
    The response from the ConfirmProductInstance service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createVolume

    public CreateVolumeResult createVolume(CreateVolumeRequest createVolumeRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  Initializes an empty volume of a given size.

  Specified by:
    `createVolume` in interface `AmazonEC2`
  Parameters:
    `createVolumeRequest` - Container for the necessary parameters to execute the CreateVolume service method on AmazonEC2.
  Returns:
    The response from the CreateVolume service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeVpnGateways

    public DescribeVpnGatewaysResult describeVpnGateways(DescribeVpnGatewaysRequest describeVpnGatewaysRequest)
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  Gives you information about your VPN gateways. You can filter the results to return information only about VPN gateways that match criteria you specify. For example, you could ask to get information about a particular VPN gateway (or all) only if the gateway's state is pending or available. You can specify multiple filters (e.g., the VPN gateway is in a particular Availability Zone and the gateway's state is pending or available). The result includes information for a particular VPN gateway only if the gateway matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeVpnGateways` in interface `AmazonEC2`
  Parameters:
    `describeVpnGatewaysRequest` - Container for the necessary parameters to execute the DescribeVpnGateways service method on AmazonEC2.
  Returns:
    The response from the DescribeVpnGateways service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createSubnet

    public CreateSubnetResult createSubnet(CreateSubnetRequest createSubnetRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  Creates a subnet in an existing VPC. You can create up to 20 subnets in a VPC. If you add more than one subnet to a VPC, they're set up in a star topology with a logical router in the middle. When you create each subnet, you provide the VPC ID and the CIDR block you want for the subnet. Once you create a subnet, you can't change its CIDR block. The subnet's CIDR block can be the same as the VPC's CIDR block (assuming you want only a single subnet in the VPC), or a subset of the VPC's CIDR block. If you create more than one subnet in a VPC, the subnets' CIDR blocks must not overlap. The smallest subnet (and VPC) you can create uses a /28 netmask (16 IP addresses), and the largest uses a /18 netmask (16,384 IP addresses).

  IMPORTANT: AWS reserves both the first four and the last IP address in each subnet's CIDR block. They're not available for use.

  Specified by:
    `createSubnet` in interface `AmazonEC2`
  Parameters:
    `createSubnetRequest` - Container for the necessary parameters to execute the CreateSubnet service method on AmazonEC2.
  Returns:
    The response from the CreateSubnet service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeReservedInstancesOfferings

    public DescribeReservedInstancesOfferingsResult describeReservedInstancesOfferings(DescribeReservedInstancesOfferingsRequest describeReservedInstancesOfferingsRequest)
                                                                                throws AmazonServiceException,
                                                                                       AmazonClientException

  The DescribeReservedInstancesOfferings operation describes Reserved Instance offerings that are available for purchase. With Amazon EC2 Reserved Instances, you purchase the right to launch Amazon EC2 instances for a period of time (without getting insufficient capacity errors) and pay a lower usage rate for the actual time used.

  Specified by:
    `describeReservedInstancesOfferings` in interface `AmazonEC2`
  Parameters:
    `describeReservedInstancesOfferingsRequest` - Container for the necessary parameters to execute the DescribeReservedInstancesOfferings service method on AmazonEC2.
  Returns:
    The response from the DescribeReservedInstancesOfferings service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeVolumes

    public DescribeVolumesResult describeVolumes(DescribeVolumesRequest describeVolumesRequest)
                                          throws AmazonServiceException,
                                                 AmazonClientException

  Describes the status of the indicated or, in lieu of any specified, all volumes belonging to the caller. Volumes that have been deleted are not described.

  Specified by:
    `describeVolumes` in interface `AmazonEC2`
  Parameters:
    `describeVolumesRequest` - Container for the necessary parameters to execute the DescribeVolumes service method on AmazonEC2.
  Returns:
    The response from the DescribeVolumes service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteSnapshot

    public void deleteSnapshot(DeleteSnapshotRequest deleteSnapshotRequest)
                        throws AmazonServiceException,
                               AmazonClientException

  Deletes the snapshot identified by snapshotId.

  Specified by:
    `deleteSnapshot` in interface `AmazonEC2`
  Parameters:
    `deleteSnapshotRequest` - Container for the necessary parameters to execute the DeleteSnapshot service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeDhcpOptions

    public DescribeDhcpOptionsResult describeDhcpOptions(DescribeDhcpOptionsRequest describeDhcpOptionsRequest)
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  Gives you information about one or more sets of DHCP options. You can specify one or more DHCP options set IDs, or no IDs (to describe all your sets of DHCP options). The returned information consists of:

  - The DHCP options set ID
  - The options

  Specified by:
    `describeDhcpOptions` in interface `AmazonEC2`
  Parameters:
    `describeDhcpOptionsRequest` - Container for the necessary parameters to execute the DescribeDhcpOptions service method on AmazonEC2.
  Returns:
    The response from the DescribeDhcpOptions service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### monitorInstances

    public MonitorInstancesResult monitorInstances(MonitorInstancesRequest monitorInstancesRequest)
                                            throws AmazonServiceException,
                                                   AmazonClientException

  Enables monitoring for a running instance.

  Specified by:
    `monitorInstances` in interface `AmazonEC2`
  Parameters:
    `monitorInstancesRequest` - Container for the necessary parameters to execute the MonitorInstances service method on AmazonEC2.
  Returns:
    The response from the MonitorInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### disassociateAddress

    public void disassociateAddress(DisassociateAddressRequest disassociateAddressRequest)
                             throws AmazonServiceException,
                                    AmazonClientException

  The DisassociateAddress operation disassociates the specified elastic IP address from the instance to which it is assigned. This is an idempotent operation. If you enter it more than once, Amazon EC2 does not return an error.

  Specified by:
    `disassociateAddress` in interface `AmazonEC2`
  Parameters:
    `disassociateAddressRequest` - Container for the necessary parameters to execute the DisassociateAddress service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createPlacementGroup

    public void createPlacementGroup(CreatePlacementGroupRequest createPlacementGroupRequest)
                              throws AmazonServiceException,
                                     AmazonClientException

  Creates a PlacementGroup into which multiple Amazon EC2 instances can be launched. Users must give the group a name unique within the scope of the user account.

  Specified by:
    `createPlacementGroup` in interface `AmazonEC2`
  Parameters:
    `createPlacementGroupRequest` - Container for the necessary parameters to execute the CreatePlacementGroup service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeBundleTasks

    public DescribeBundleTasksResult describeBundleTasks(DescribeBundleTasksRequest describeBundleTasksRequest)
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  The DescribeBundleTasks operation describes in-progress and recent bundle tasks. Complete and failed tasks are removed from the list a short time after completion. If no bundle ids are given, all bundle tasks are returned.

  Specified by:
    `describeBundleTasks` in interface `AmazonEC2`
  Parameters:
    `describeBundleTasksRequest` - Container for the necessary parameters to execute the DescribeBundleTasks service method on AmazonEC2.
  Returns:
    The response from the DescribeBundleTasks service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### bundleInstance

    public BundleInstanceResult bundleInstance(BundleInstanceRequest bundleInstanceRequest)
                                        throws AmazonServiceException,
                                               AmazonClientException

  The BundleInstance operation request that an instance is bundled the next time it boots. The bundling process creates a new image from a running instance and stores the AMI data in S3. Once bundled, the image must be registered in the normal way using the RegisterImage API.

  Specified by:
    `bundleInstance` in interface `AmazonEC2`
  Parameters:
    `bundleInstanceRequest` - Container for the necessary parameters to execute the BundleInstance service method on AmazonEC2.
  Returns:
    The response from the BundleInstance service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deletePlacementGroup

    public void deletePlacementGroup(DeletePlacementGroupRequest deletePlacementGroupRequest)
                              throws AmazonServiceException,
                                     AmazonClientException

  Deletes a PlacementGroup from a user's account. Terminate all Amazon EC2 instances in the placement group before deletion.

  Specified by:
    `deletePlacementGroup` in interface `AmazonEC2`
  Parameters:
    `deletePlacementGroupRequest` - Container for the necessary parameters to execute the DeletePlacementGroup service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### revokeSecurityGroupIngress

    public void revokeSecurityGroupIngress(RevokeSecurityGroupIngressRequest revokeSecurityGroupIngressRequest)
                                    throws AmazonServiceException,
                                           AmazonClientException

  The RevokeSecurityGroupIngress operation revokes permissions from a security group. The permissions used to revoke must be specified using the same values used to grant the permissions.

  Permissions are specified by IP protocol (TCP, UDP, or ICMP), the source of the request (by IP range or an Amazon EC2 user-group pair), the source and destination port ranges (for TCP and UDP), and the ICMP codes and types (for ICMP).

  Permission changes are quickly propagated to instances within the security group. However, depending on the number of instances in the group, a small delay is might occur, .

  When revoking a user/group pair permission, GroupName, SourceSecurityGroupName and SourceSecurityGroupOwnerId must be specified. When authorizing a CIDR IP permission, GroupName, IpProtocol, FromPort, ToPort and CidrIp must be specified. Mixing these two types of parameters is not allowed.

  Specified by:
    `revokeSecurityGroupIngress` in interface `AmazonEC2`
  Parameters:
    `revokeSecurityGroupIngressRequest` - Container for the necessary parameters to execute the RevokeSecurityGroupIngress service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteVpc

    public void deleteVpc(DeleteVpcRequest deleteVpcRequest)
                   throws AmazonServiceException,
                          AmazonClientException

  Deletes a VPC. You must terminate all running instances and delete all subnets before deleting the VPC, otherwise Amazon VPC returns an error.

  Specified by:
    `deleteVpc` in interface `AmazonEC2`
  Parameters:
    `deleteVpcRequest` - Container for the necessary parameters to execute the DeleteVpc service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### getConsoleOutput

    public GetConsoleOutputResult getConsoleOutput(GetConsoleOutputRequest getConsoleOutputRequest)
                                            throws AmazonServiceException,
                                                   AmazonClientException

  The GetConsoleOutput operation retrieves console output for the specified instance.

  Instance console output is buffered and posted shortly after instance boot, reboot, and termination. Amazon EC2 preserves the most recent 64 KB output which will be available for at least one hour after the most recent post.

  Specified by:
    `getConsoleOutput` in interface `AmazonEC2`
  Parameters:
    `getConsoleOutputRequest` - Container for the necessary parameters to execute the GetConsoleOutput service method on AmazonEC2.
  Returns:
    The response from the GetConsoleOutput service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### allocateAddress

    public AllocateAddressResult allocateAddress(AllocateAddressRequest allocateAddressRequest)
                                          throws AmazonServiceException,
                                                 AmazonClientException

  The AllocateAddress operation acquires an elastic IP address for use with your account.

  Specified by:
    `allocateAddress` in interface `AmazonEC2`
  Parameters:
    `allocateAddressRequest` - Container for the necessary parameters to execute the AllocateAddress service method on AmazonEC2.
  Returns:
    The response from the AllocateAddress service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### modifyImageAttribute

    public void modifyImageAttribute(ModifyImageAttributeRequest modifyImageAttributeRequest)
                              throws AmazonServiceException,
                                     AmazonClientException

  The ModifyImageAttribute operation modifies an attribute of an AMI.

  Specified by:
    `modifyImageAttribute` in interface `AmazonEC2`
  Parameters:
    `modifyImageAttributeRequest` - Container for the necessary parameters to execute the ModifyImageAttribute service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### releaseAddress

    public void releaseAddress(ReleaseAddressRequest releaseAddressRequest)
                        throws AmazonServiceException,
                               AmazonClientException

  The ReleaseAddress operation releases an elastic IP address associated with your account.

  NOTE: Releasing an IP address automatically disassociates it from any instance with which it is associated. For more information, see DisassociateAddress.

  IMPORTANT: After releasing an elastic IP address, it is released to the IP address pool and might no longer be available to your account. Make sure to update your DNS records and any servers or devices that communicate with the address. If you run this operation on an elastic IP address that is already released, the address might be assigned to another account which will cause Amazon EC2 to return an error.

  Specified by:
    `releaseAddress` in interface `AmazonEC2`
  Parameters:
    `releaseAddressRequest` - Container for the necessary parameters to execute the ReleaseAddress service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createCustomerGateway

    public CreateCustomerGatewayResult createCustomerGateway(CreateCustomerGatewayRequest createCustomerGatewayRequest)
                                                      throws AmazonServiceException,
                                                             AmazonClientException

  Provides information to AWS about your customer gateway device. The customer gateway is the appliance at your end of the VPN connection (compared to the VPN gateway, which is the device at the AWS side of the VPN connection). You can have a single active customer gateway per AWS account (active means that you've created a VPN connection to use with the customer gateway). AWS might delete any customer gateway that you create with this operation if you leave it inactive for an extended period of time.

  You must provide the Internet-routable IP address of the customer gateway's external interface. The IP address must be static.

  You must also provide the device's Border Gateway Protocol (BGP) Autonomous System Number (ASN). You can use an existing ASN assigned to your network. If you don't have an ASN already, you can use a private ASN (in the 64512 - 65534 range). For more information about ASNs, go to http://en.wikipedia.org/wiki/Autonomous_system_%28Internet%29 .

  Specified by:
    `createCustomerGateway` in interface `AmazonEC2`
  Parameters:
    `createCustomerGatewayRequest` - Container for the necessary parameters to execute the CreateCustomerGateway service method on AmazonEC2.
  Returns:
    The response from the CreateCustomerGateway service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### resetInstanceAttribute

    public void resetInstanceAttribute(ResetInstanceAttributeRequest resetInstanceAttributeRequest)
                                throws AmazonServiceException,
                                       AmazonClientException

  Resets an attribute of an instance to its default value.

  Specified by:
    `resetInstanceAttribute` in interface `AmazonEC2`
  Parameters:
    `resetInstanceAttributeRequest` - Container for the necessary parameters to execute the ResetInstanceAttribute service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createSpotDatafeedSubscription

    public CreateSpotDatafeedSubscriptionResult createSpotDatafeedSubscription(CreateSpotDatafeedSubscriptionRequest createSpotDatafeedSubscriptionRequest)
                                                                        throws AmazonServiceException,
                                                                               AmazonClientException

  Creates the data feed for Spot Instances, enabling you to view Spot Instance usage logs. You can create one data feed per account.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `createSpotDatafeedSubscription` in interface `AmazonEC2`
  Parameters:
    `createSpotDatafeedSubscriptionRequest` - Container for the necessary parameters to execute the CreateSpotDatafeedSubscription service method on AmazonEC2.
  Returns:
    The response from the CreateSpotDatafeedSubscription service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createKeyPair

    public CreateKeyPairResult createKeyPair(CreateKeyPairRequest createKeyPairRequest)
                                      throws AmazonServiceException,
                                             AmazonClientException

  The CreateKeyPair operation creates a new 2048 bit RSA key pair and returns a unique ID that can be used to reference this key pair when launching new instances. For more information, see RunInstances.

  Specified by:
    `createKeyPair` in interface `AmazonEC2`
  Parameters:
    `createKeyPairRequest` - Container for the necessary parameters to execute the CreateKeyPair service method on AmazonEC2.
  Returns:
    The response from the CreateKeyPair service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSnapshots

    public DescribeSnapshotsResult describeSnapshots(DescribeSnapshotsRequest describeSnapshotsRequest)
                                              throws AmazonServiceException,
                                                     AmazonClientException

  Describes the indicated snapshots, or in lieu of that, all snapshots owned by the caller.

  Specified by:
    `describeSnapshots` in interface `AmazonEC2`
  Parameters:
    `describeSnapshotsRequest` - Container for the necessary parameters to execute the DescribeSnapshots service method on AmazonEC2.
  Returns:
    The response from the DescribeSnapshots service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### registerImage

    public RegisterImageResult registerImage(RegisterImageRequest registerImageRequest)
                                      throws AmazonServiceException,
                                             AmazonClientException

  The RegisterImage operation registers an AMI with Amazon EC2. Images must be registered before they can be launched. For more information, see RunInstances.

  Each AMI is associated with an unique ID which is provided by the Amazon EC2 service through the RegisterImage operation. During registration, Amazon EC2 retrieves the specified image manifest from Amazon S3 and verifies that the image is owned by the user registering the image.

  The image manifest is retrieved once and stored within the Amazon EC2. Any modifications to an image in Amazon S3 invalidates this registration. If you make changes to an image, deregister the previous image and register the new image. For more information, see DeregisterImage.

  Specified by:
    `registerImage` in interface `AmazonEC2`
  Parameters:
    `registerImageRequest` - Container for the necessary parameters to execute the RegisterImage service method on AmazonEC2.
  Returns:
    The response from the RegisterImage service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteVpnConnection

    public void deleteVpnConnection(DeleteVpnConnectionRequest deleteVpnConnectionRequest)
                             throws AmazonServiceException,
                                    AmazonClientException

  Deletes a VPN connection. Use this if you want to delete a VPC and all its associated components. Another reason to use this operation is if you believe the tunnel credentials for your VPN connection have been compromised. In that situation, you can delete the VPN connection and create a new one that has new keys, without needing to delete the VPC or VPN gateway. If you create a new VPN connection, you must reconfigure the customer gateway using the new configuration information returned with the new VPN connection ID.

  If you're deleting the VPC and all its associated parts, we recommend you detach the VPN gateway from the VPC and delete the VPC before deleting the VPN connection.

  Specified by:
    `deleteVpnConnection` in interface `AmazonEC2`
  Parameters:
    `deleteVpnConnectionRequest` - Container for the necessary parameters to execute the DeleteVpnConnection service method on AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### createVpnConnection

    public CreateVpnConnectionResult createVpnConnection(CreateVpnConnectionRequest createVpnConnectionRequest)
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  Creates a new VPN connection between an existing VPN gateway and customer gateway. The only supported connection type is ipsec.1.

  The response includes information that you need to configure your customer gateway, in XML format. We recommend you use the command line version of this operation (ec2-create-vpn-connection), which takes an -f option (for format) and returns configuration information formatted as expected by the vendor you specified, or in a generic, human readable format. For information about the command, go to ec2-create-vpn-connection in the Amazon Virtual Private Cloud Command Line Reference.

  IMPORTANT: We strongly recommend you use HTTPS when calling this operation because the response contains sensitive cryptographic information for configuring your customer gateway. If you decide to shut down your VPN connection for any reason and then create a new one, you must re-configure your customer gateway with the new information returned from this call.

  Specified by:
    `createVpnConnection` in interface `AmazonEC2`
  Parameters:
    `createVpnConnectionRequest` - Container for the necessary parameters to execute the CreateVpnConnection service method on AmazonEC2.
  Returns:
    The response from the CreateVpnConnection service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeInstanceAttribute

    public DescribeInstanceAttributeResult describeInstanceAttribute(DescribeInstanceAttributeRequest describeInstanceAttributeRequest)
                                                              throws AmazonServiceException,
                                                                     AmazonClientException

  Returns information about an attribute of an instance. Only one attribute can be specified per call.

  Specified by:
    `describeInstanceAttribute` in interface `AmazonEC2`
  Parameters:
    `describeInstanceAttributeRequest` - Container for the necessary parameters to execute the DescribeInstanceAttribute service method on AmazonEC2.
  Returns:
    The response from the DescribeInstanceAttribute service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describePlacementGroups

    public DescribePlacementGroupsResult describePlacementGroups()
                                                          throws AmazonServiceException,
                                                                 AmazonClientException

  Returns information about one or more PlacementGroup instances in a user's account.

  Specified by:
    `describePlacementGroups` in interface `AmazonEC2`
  Returns:
    The response from the DescribePlacementGroups service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeReservedInstances

    public DescribeReservedInstancesResult describeReservedInstances()
                                                              throws AmazonServiceException,
                                                                     AmazonClientException

  The DescribeReservedInstances operation describes Reserved Instances that were purchased for use with your account.

  Specified by:
    `describeReservedInstances` in interface `AmazonEC2`
  Returns:
    The response from the DescribeReservedInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSubnets

    public DescribeSubnetsResult describeSubnets()
                                          throws AmazonServiceException,
                                                 AmazonClientException

  Gives you information about your subnets. You can filter the results to return information only about subnets that match criteria you specify. For example, you could ask to get information about a particular subnet (or all) only if the subnet's state is available. You can specify multiple filters (e.g., the subnet is in a particular VPC, and the subnet's state is available). The result includes information for a particular subnet only if the subnet matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeSubnets` in interface `AmazonEC2`
  Returns:
    The response from the DescribeSubnets service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeAvailabilityZones

    public DescribeAvailabilityZonesResult describeAvailabilityZones()
                                                              throws AmazonServiceException,
                                                                     AmazonClientException

  The DescribeAvailabilityZones operation describes availability zones that are currently available to the account and their states.

  Availability zones are not the same across accounts. The availability zone us-east-1a for account A is not necessarily the same as us-east-1a for account B. Zone assignments are mapped independently for each account.

  Specified by:
    `describeAvailabilityZones` in interface `AmazonEC2`
  Returns:
    The response from the DescribeAvailabilityZones service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeInstances

    public DescribeInstancesResult describeInstances()
                                              throws AmazonServiceException,
                                                     AmazonClientException

  The DescribeInstances operation returns information about instances that you own.

  If you specify one or more instance IDs, Amazon EC2 returns information for those instances. If you do not specify instance IDs, Amazon EC2 returns information for all relevant instances. If you specify an invalid instance ID, a fault is returned. If you specify an instance that you do not own, it will not be included in the returned results.

  Recently terminated instances might appear in the returned results. This interval is usually less than one hour.

  Specified by:
    `describeInstances` in interface `AmazonEC2`
  Returns:
    The response from the DescribeInstances service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeImages

    public DescribeImagesResult describeImages()
                                        throws AmazonServiceException,
                                               AmazonClientException

  The DescribeImages operation returns information about AMIs, AKIs, and ARIs available to the user. Information returned includes image type, product codes, architecture, and kernel and RAM disk IDs. Images available to the user include public images available for any user to launch, private images owned by the user making the request, and private images owned by other users for which the user has explicit launch permissions.

  Launch permissions fall into three categories:

  - Public: The owner of the AMI granted launch permissions for the AMI to the all group. All users have launch permissions for these AMIs.
  - Explicit: The owner of the AMI granted launch permissions to a specific user.
  - Implicit: A user has implicit launch permissions for all AMIs he or she owns.

  The list of AMIs returned can be modified by specifying AMI IDs, AMI owners, or users with launch permissions. If no options are specified, Amazon EC2 returns all AMIs for which the user has launch permissions.

  If you specify one or more AMI IDs, only AMIs that have the specified IDs are returned. If you specify an invalid AMI ID, a fault is returned. If you specify an AMI ID for which you do not have access, it will not be included in the returned results.

  If you specify one or more AMI owners, only AMIs from the specified owners and for which you have access are returned. The results can include the account IDs of the specified owners, amazon for AMIs owned by Amazon or self for AMIs that you own.

  If you specify a list of executable users, only users that have launch permissions for the AMIs are returned. You can specify account IDs (if you own the AMI(s)), self for AMIs for which you own or have explicit permissions, or all for public AMIs.

  NOTE: Deregistered images are included in the returned results for an unspecified interval after deregistration.

  Specified by:
    `describeImages` in interface `AmazonEC2`
  Returns:
    The response from the DescribeImages service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSpotInstanceRequests

    public DescribeSpotInstanceRequestsResult describeSpotInstanceRequests()
                                                                    throws AmazonServiceException,
                                                                           AmazonClientException

  Specified by:
    `describeSpotInstanceRequests` in interface `AmazonEC2`
  Returns:
    The response from the DescribeSpotInstanceRequests service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeCustomerGateways

    public DescribeCustomerGatewaysResult describeCustomerGateways()
                                                            throws AmazonServiceException,
                                                                   AmazonClientException

  Gives you information about your customer gateways. You can filter the results to return information only about customer gateways that match criteria you specify. For example, you could ask to get information about a particular customer gateway (or all) only if the gateway's state is pending or available. You can specify multiple filters (e.g., the customer gateway has a particular IP address for the Internet-routable external interface, and the gateway's state is pending or available). The result includes information for a particular customer gateway only if the gateway matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeCustomerGateways` in interface `AmazonEC2`
  Returns:
    The response from the DescribeCustomerGateways service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSpotPriceHistory

    public DescribeSpotPriceHistoryResult describeSpotPriceHistory()
                                                            throws AmazonServiceException,
                                                                   AmazonClientException

  Describes the Spot Price history.

  Spot Instances are instances that Amazon EC2 starts on your behalf when the maximum price that you specify exceeds the current Spot Price. Amazon EC2 periodically sets the Spot Price based on available Spot Instance capacity and current spot instance requests.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `describeSpotPriceHistory` in interface `AmazonEC2`
  Returns:
    The response from the DescribeSpotPriceHistory service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeRegions

    public DescribeRegionsResult describeRegions()
                                          throws AmazonServiceException,
                                                 AmazonClientException

  The DescribeRegions operation describes regions zones that are currently available to the account.

  Specified by:
    `describeRegions` in interface `AmazonEC2`
  Returns:
    The response from the DescribeRegions service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSecurityGroups

    public DescribeSecurityGroupsResult describeSecurityGroups()
                                                        throws AmazonServiceException,
                                                               AmazonClientException

  The DescribeSecurityGroups operation returns information about security groups that you own.

  If you specify security group names, information about those security group is returned. Otherwise, information for all security group is returned. If you specify a group that does not exist, a fault is returned.

  Specified by:
    `describeSecurityGroups` in interface `AmazonEC2`
  Returns:
    The response from the DescribeSecurityGroups service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSpotDatafeedSubscription

    public DescribeSpotDatafeedSubscriptionResult describeSpotDatafeedSubscription()
                                                                            throws AmazonServiceException,
                                                                                   AmazonClientException

  Describes the data feed for Spot Instances.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `describeSpotDatafeedSubscription` in interface `AmazonEC2`
  Returns:
    The response from the DescribeSpotDatafeedSubscription service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeLicenses

    public DescribeLicensesResult describeLicenses()
                                            throws AmazonServiceException,
                                                   AmazonClientException

  Provides details of a user's registered licenses. Zero or more IDs may be specified on the call. When one or more license IDs are specified, only data for the specified IDs are returned.

  Specified by:
    `describeLicenses` in interface `AmazonEC2`
  Returns:
    The response from the DescribeLicenses service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeVpnConnections

    public DescribeVpnConnectionsResult describeVpnConnections()
                                                        throws AmazonServiceException,
                                                               AmazonClientException

  Gives you information about your VPN connections.

  IMPORTANT: We strongly recommend you use HTTPS when calling this operation because the response contains sensitive cryptographic information for configuring your customer gateway. You can filter the results to return information only about VPN connections that match criteria you specify. For example, you could ask to get information about a particular VPN connection (or all) only if the VPN's state is pending or available. You can specify multiple filters (e.g., the VPN connection is associated with a particular VPN gateway, and the gateway's state is pending or available). The result includes information for a particular VPN connection only if the VPN connection matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeVpnConnections` in interface `AmazonEC2`
  Returns:
    The response from the DescribeVpnConnections service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### deleteSpotDatafeedSubscription

    public void deleteSpotDatafeedSubscription()
                                        throws AmazonServiceException,
                                               AmazonClientException

  Deletes the data feed for Spot Instances.

  For conceptual information about Spot Instances, refer to the Amazon Elastic Compute Cloud Developer Guide or Amazon Elastic Compute Cloud User Guide .

  Specified by:
    `deleteSpotDatafeedSubscription` in interface `AmazonEC2`
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeVpcs

    public DescribeVpcsResult describeVpcs()
                                    throws AmazonServiceException,
                                           AmazonClientException

  Gives you information about your VPCs. You can filter the results to return information only about VPCs that match criteria you specify. For example, you could ask to get information about a particular VPC or VPCs (or all your VPCs) only if the VPC's state is available. You can specify multiple filters (e.g., the VPC uses one of several sets of DHCP options, and the VPC's state is available). The result includes information for a particular VPC only if the VPC matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeVpcs` in interface `AmazonEC2`
  Returns:
    The response from the DescribeVpcs service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeAddresses

    public DescribeAddressesResult describeAddresses()
                                              throws AmazonServiceException,
                                                     AmazonClientException

  The DescribeAddresses operation lists elastic IP addresses assigned to your account.

  Specified by:
    `describeAddresses` in interface `AmazonEC2`
  Returns:
    The response from the DescribeAddresses service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeKeyPairs

    public DescribeKeyPairsResult describeKeyPairs()
                                            throws AmazonServiceException,
                                                   AmazonClientException

  The DescribeKeyPairs operation returns information about key pairs available to you. If you specify key pairs, information about those key pairs is returned. Otherwise, information for all registered key pairs is returned.

  Specified by:
    `describeKeyPairs` in interface `AmazonEC2`
  Returns:
    The response from the DescribeKeyPairs service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeVpnGateways

    public DescribeVpnGatewaysResult describeVpnGateways()
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  Gives you information about your VPN gateways. You can filter the results to return information only about VPN gateways that match criteria you specify. For example, you could ask to get information about a particular VPN gateway (or all) only if the gateway's state is pending or available. You can specify multiple filters (e.g., the VPN gateway is in a particular Availability Zone and the gateway's state is pending or available). The result includes information for a particular VPN gateway only if the gateway matches all your filters. If there's no match, no special message is returned; the response is simply empty. The following table shows the available filters.

  Specified by:
    `describeVpnGateways` in interface `AmazonEC2`
  Returns:
    The response from the DescribeVpnGateways service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeReservedInstancesOfferings

    public DescribeReservedInstancesOfferingsResult describeReservedInstancesOfferings()
                                                                                throws AmazonServiceException,
                                                                                       AmazonClientException

  The DescribeReservedInstancesOfferings operation describes Reserved Instance offerings that are available for purchase. With Amazon EC2 Reserved Instances, you purchase the right to launch Amazon EC2 instances for a period of time (without getting insufficient capacity errors) and pay a lower usage rate for the actual time used.

  Specified by:
    `describeReservedInstancesOfferings` in interface `AmazonEC2`
  Returns:
    The response from the DescribeReservedInstancesOfferings service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeDhcpOptions

    public DescribeDhcpOptionsResult describeDhcpOptions()
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  Gives you information about one or more sets of DHCP options. You can specify one or more DHCP options set IDs, or no IDs (to describe all your sets of DHCP options). The returned information consists of:

  - The DHCP options set ID
  - The options

  Specified by:
    `describeDhcpOptions` in interface `AmazonEC2`
  Returns:
    The response from the DescribeDhcpOptions service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeBundleTasks

    public DescribeBundleTasksResult describeBundleTasks()
                                                  throws AmazonServiceException,
                                                         AmazonClientException

  The DescribeBundleTasks operation describes in-progress and recent bundle tasks. Complete and failed tasks are removed from the list a short time after completion. If no bundle ids are given, all bundle tasks are returned.

  Specified by:
    `describeBundleTasks` in interface `AmazonEC2`
  Returns:
    The response from the DescribeBundleTasks service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### allocateAddress

    public AllocateAddressResult allocateAddress()
                                          throws AmazonServiceException,
                                                 AmazonClientException

  The AllocateAddress operation acquires an elastic IP address for use with your account.

  Specified by:
    `allocateAddress` in interface `AmazonEC2`
  Returns:
    The response from the AllocateAddress service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

### describeSnapshots

    public DescribeSnapshotsResult describeSnapshots()
                                              throws AmazonServiceException,
                                                     AmazonClientException

  Describes the indicated snapshots, or in lieu of that, all snapshots owned by the caller.

  Specified by:
    `describeSnapshots` in interface `AmazonEC2`
  Returns:
    The response from the DescribeSnapshots service method, as returned by AmazonEC2.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonEC2 indicating either a problem with the data in the request, or a server side issue.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.